## fcitx5 5.1.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(fcitx VERSION 5.1.14)
set(FCITX_VERSION ${PROJECT_VERSION})

find_package(ECM REQUIRED 1.0.0)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH})

#######################################################################
# CMake macros
#######################################################################
include(FeatureSummary)
include(GNUInstallDirs)
include(ECMSetupVersion)
include(GenerateExportHeader)
include(WriteBasicConfigVersionFile)
include(ECMUninstallTarget)
include(src/lib/fcitx-utils/Fcitx5Macros.cmake)
include(CheckSymbolExists)
include(CheckIncludeFile)
include(CheckCXXCompilerFlag)

#######################################################################
# Options
#######################################################################
option(ENABLE_TESTING_ADDONS "Build testing frontend, im and ui addons" On)
option(ENABLE_TEST "Build Test (Need ENABLE_TESTING_ADDONS=On)" On)
option(ENABLE_COVERAGE "Build the project with gcov support (Need ENABLE_TEST=On)" Off)
set(GCOV_TOOL "gcov" CACHE STRING "Path to gcov tool used by coverage.")
set(DEFAULT_XKB_RULES "evdev" CACHE STRING "Xkb rules name")
option(ENABLE_ENCHANT "Enable enchant for word predication" On)
option(ENABLE_X11 "Enable X11 support" On)
option(ENABLE_WAYLAND "Enable wayland support" On)
option(ENABLE_DBUS "Enable DBus" On)
option(ENABLE_DOC "Build doxygen" Off)
option(ENABLE_SERVER "Build a fcitx as server, disable this option if you want to use fcitx as an embedded library." On)
option(ENABLE_KEYBOARD "Enable key event translation with XKB and build keyboard engine" On)
option(USE_SYSTEMD "Use systemd for event loop and dbus, will fallback to libuv/libdbus if not found. Only used when EVENT_LOOP_BACKEND is auto." On)
option(ENABLE_XDGAUTOSTART "Enable xdg autostart desktop file installation" On)
option(USE_FLATPAK_ICON "Use flatpak icon name for desktop files" Off)
option(ENABLE_EMOJI "Enable emoji module" On)
option(ENABLE_LIBUUID "Use libuuid for uuid generation" On)
option(BUILD_SPELL_DICT "Build en_dict.fscd for English spell check" On)
option(BUILD_SHARED_LIBS "Build library as shared libs" On)
set(NO_PREEDIT_APPS "gvim.*,wps.*,wpp.*,et.*" CACHE STRING "Disable preedit for follwing app by default.")
set(EVENT_LOOP_BACKEND "auto" CACHE STRING "Set the underlying event loop implementation, valid values are auto,systemd,libuv,none")

if (ENABLE_EMOJI)
    find_package(ZLIB REQUIRED)
endif()

if ((ENABLE_WAYLAND OR ENABLE_X11) AND NOT ENABLE_KEYBOARD)
    message(FATAL_ERROR "X11 and Wayland require ENABLE_KEYBOARD to be set to ON.")
endif ()

#######################################################################
# Find packages
#######################################################################

find_package(PkgConfig REQUIRED)

set(CANDIDATE_EVENT_LOOP_BACKENDS)

if (EVENT_LOOP_BACKEND STREQUAL "auto")
    if (USE_SYSTEMD)
        list(APPEND CANDIDATE_EVENT_LOOP_BACKENDS systemd)
    endif()

    list(APPEND CANDIDATE_EVENT_LOOP_BACKENDS libuv)
elseif (EVENT_LOOP_BACKEND STREQUAL "systemd")
    list(APPEND CANDIDATE_EVENT_LOOP_BACKENDS systemd)
elseif (EVENT_LOOP_BACKEND STREQUAL "libuv")
    list(APPEND CANDIDATE_EVENT_LOOP_BACKENDS libuv)
elseif (EVENT_LOOP_BACKEND STREQUAL "none")
    list(APPEND CANDIDATE_EVENT_LOOP_BACKENDS none)
endif()

set(FCITX_EVENT_LOOP_BACKEND "")
foreach(CANDIDATE_EVENT_LOOP_BACKEND IN LISTS CANDIDATE_EVENT_LOOP_BACKENDS)
    if (CANDIDATE_EVENT_LOOP_BACKEND STREQUAL systemd)
        find_package(Systemd)
        if (TARGET Systemd::Systemd)
            set(FCITX_EVENT_LOOP_BACKEND "systemd")
            break()
        endif()
    elseif (CANDIDATE_EVENT_LOOP_BACKEND STREQUAL libuv)
        if (NOT LIBUV_TARGET)
            if (NOT (TARGET PkgConfig::LibUV))
                pkg_check_modules(LibUV IMPORTED_TARGET "libuv")
                set(LIBUV_TARGET PkgConfig::LibUV)
            endif()
        endif()

        if (TARGET "${LIBUV_TARGET}")
            set(FCITX_EVENT_LOOP_BACKEND "libuv")
            break()
        endif()
    elseif (CANDIDATE_EVENT_LOOP_BACKEND STREQUAL none)
        set(FCITX_EVENT_LOOP_BACKEND "none")
        break()
    endif()
endforeach()

if (ENABLE_DBUS AND NOT (FCITX_EVENT_LOOP_BACKEND STREQUAL systemd))
    pkg_check_modules(DBus REQUIRED IMPORTED_TARGET "dbus-1")
    pkg_get_variable(DBUS_SYSTEM_BUS_DEFAULT_ADDRESS "dbus-1" "system_bus_default_address")
endif()

if (FCITX_EVENT_LOOP_BACKEND STREQUAL "")
    message(FATAL_ERROR "Failed to find a valid event loop backend. Backends checked: ${CANDIDATE_EVENT_LOOP_BACKENDS}")
endif()

if (USE_FLATPAK_ICON)
    set(FCITX_ICON_NAME "org.fcitx.Fcitx5")
else()
    set(FCITX_ICON_NAME "fcitx")
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "BSD|DragonFly")
    find_package(LibKVM REQUIRED)
endif()
find_package(DL REQUIRED)

if (NOT TARGET LibIntl::LibIntl)
    find_package(LibIntl REQUIRED)
endif()

if (ENABLE_LIBUUID)
    find_package(LibUUID REQUIRED)
endif()

find_package(Pthread REQUIRED)
find_package(Execinfo)
find_package(Gettext REQUIRED)

set(REQUIRED_XKBCOMMON_COMPONENTS XKBCommon)
if (ENABLE_X11)
    set(REQUIRED_XKBCOMMON_COMPONENTS ${REQUIRED_XKBCOMMON_COMPONENTS} X11)
    find_package(XCB REQUIRED COMPONENTS XCB AUX XKB XFIXES ICCCM XINERAMA RANDR EWMH KEYSYMS)
    find_package(XCBImdkit 1.0.3 REQUIRED)
    pkg_check_modules(CairoXCB REQUIRED IMPORTED_TARGET cairo-xcb)
    pkg_check_modules(XkbFile REQUIRED IMPORTED_TARGET "xkbfile")
endif()

if (ENABLE_KEYBOARD)
    find_package(Expat REQUIRED)
endif()

if (ENABLE_KEYBOARD)
    find_package(XKBCommon REQUIRED COMPONENTS ${REQUIRED_XKBCOMMON_COMPONENTS})
    find_package(IsoCodes REQUIRED)
    find_package(XKeyboardConfig REQUIRED)
    pkg_check_modules(JsonC REQUIRED IMPORTED_TARGET "json-c")

    set(DEFAULT_XKB_RULES_FILES "${XKEYBOARDCONFIG_XKBBASE}/rules/${DEFAULT_XKB_RULES}.xml")
    if (NOT EXISTS "${DEFAULT_XKB_RULES_FILES}" AND NOT APPLE)
        message(WARNING "Could not find default xkb rules file: ${DEFAULT_XKB_RULES_FILES}")
    endif()
endif()

# Library for classicui painting
if (ENABLE_X11 OR ENABLE_WAYLAND)
    pkg_check_modules(Cairo IMPORTED_TARGET cairo)
    pkg_check_modules(Pango IMPORTED_TARGET pango pangocairo)
    pkg_check_modules(GdkPixbuf IMPORTED_TARGET gdk-pixbuf-2.0)
    pkg_check_modules(GioUnix IMPORTED_TARGET gio-unix-2.0)
endif()

if (ENABLE_WAYLAND)
    set(REQUIRED_WAYLAND_COMPONENTS Client Cursor)
    find_package(Wayland 1.22 REQUIRED COMPONENTS ${REQUIRED_WAYLAND_COMPONENTS})
    find_package(WaylandScanner REQUIRED)
    find_package(WaylandProtocols REQUIRED)
    pkg_check_modules(Gio IMPORTED_TARGET gio-2.0)
endif()

if(ENABLE_ENCHANT)
  pkg_check_modules(Enchant IMPORTED_TARGET "enchant-2")
  if(NOT TARGET PkgConfig::Enchant)
    pkg_check_modules(Enchant IMPORTED_TARGET "enchant" REQUIRED)
  endif()
endif()

if (TARGET Wayland::Client AND ENABLE_WAYLAND)
    set(WAYLAND_FOUND TRUE)
else()
    set(WAYLAND_FOUND FALSE)
endif()

# directory needed by bsd
if(NOT CMAKE_INSTALL_LIBDATADIR)
  set(CMAKE_INSTALL_LIBDATADIR "${CMAKE_INSTALL_LIBDIR}" CACHE PATH "libdata root (LIBDIR)")
endif()

GNUInstallDirs_get_absolute_install_dir(CMAKE_INSTALL_FULL_LIBDATADIR CMAKE_INSTALL_LIBDATADIR LIBDATADIR)
mark_as_advanced(CMAKE_INSTALL_LIBDATADIR)
mark_as_advanced(CMAKE_INSTALL_FULL_LIBDATADIR)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

include(Fcitx5CompilerSettings)
check_cxx_compiler_flag(-Wno-deprecated-declarations HAVE_NO_DEPRECATED_DECLARATIONS)

set(FCITX_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set(FCITX_INSTALL_SYSCONFDIR ${CMAKE_INSTALL_FULL_SYSCONFDIR})
set(FCITX_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(FCITX_INSTALL_LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})
set(FCITX_INSTALL_LIBDATADIR ${CMAKE_INSTALL_FULL_LIBDATADIR})
set(FCITX_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_FULL_LIBEXECDIR})
set(FCITX_INSTALL_DATADIR ${CMAKE_INSTALL_FULL_DATADIR})
set(FCITX_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/fcitx5")
set(FCITX_INSTALL_BINDIR ${CMAKE_INSTALL_FULL_BINDIR})
set(FCITX_INSTALL_LOCALEDIR ${CMAKE_INSTALL_FULL_LOCALEDIR})
set(FCITX_INSTALL_ADDONDIR "${CMAKE_INSTALL_FULL_LIBDIR}/fcitx5")
set(FCITX_INSTALL_CMAKECONFIG_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/cmake")
set(FCITX_INSTALL_MODULE_HEADER_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/Fcitx5/Module/fcitx-module")

if (WIN32)
    set(FCITX_LIBRARY_SUFFIX ".dll")
else()
    set(FCITX_LIBRARY_SUFFIX ".so")
endif()

check_function_exists(pipe2 HAVE_PIPE2)
check_include_file(sys/wait.h HAVE_SYS_WAIT_H)
check_include_file(sys/mman.h HAVE_SYS_MMAN_H)
check_include_file(sys/uio.h HAVE_SYS_UIO_H)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(po)

if (ENABLE_TESTING_ADDONS)
  add_subdirectory(testing)
endif()

#######################################################################
# Test features
#######################################################################
if (ENABLE_TEST)
    enable_testing()
    add_subdirectory(test)

    if (ENABLE_COVERAGE)
        add_custom_target(coverage
                        COMMAND "${CMAKE_CTEST_COMMAND}"
                        COMMAND lcov --gcov-tool "${GCOV_TOOL}" --no-external --capture --directory ./ -b "${CMAKE_CURRENT_SOURCE_DIR}" --output-file coverage.info
                        COMMAND genhtml coverage.info --output-directory "coverage_pages"
                        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    endif()
endif ()

if (ENABLE_DOC)
  find_package(Doxygen REQUIRED)
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/.codedocs" FCITX_DOXYGEN_CONFIGURATION)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY)
  add_custom_target(doc
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "Generating API documentation with Doxygen"
      VERBATIM)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== testing/CMakeLists.txt ===
add_subdirectory(testfrontend)
add_subdirectory(testim)
add_subdirectory(testui)

=== src/im/CMakeLists.txt ===
if (ENABLE_KEYBOARD)
    add_subdirectory(keyboard)
endif()

=== src/tools/CMakeLists.txt ===
if (ENABLE_DBUS)
    add_executable(fcitx5-remote remote.cpp)
    target_link_libraries(fcitx5-remote Fcitx5::Utils)

    install(TARGETS fcitx5-remote DESTINATION "${FCITX_INSTALL_BINDIR}")
endif()

if (ENABLE_DBUS AND WAYLAND_FOUND)
    add_executable(fcitx5-wayland-launcher wayland-launcher.cpp)
    target_link_libraries(fcitx5-wayland-launcher Fcitx5::Utils)

    install(TARGETS fcitx5-wayland-launcher DESTINATION "${FCITX_INSTALL_LIBEXECDIR}")
endif()

=== src/frontend/ibusfrontend/CMakeLists.txt ===
add_fcitx5_addon(ibusfrontend ibusfrontend.cpp)
target_link_libraries(ibusfrontend Fcitx5::Core Fcitx5::Module::DBus)
install(TARGETS ibusfrontend DESTINATION "${FCITX_INSTALL_ADDONDIR}")
configure_file(ibusfrontend.conf.in.in ibusfrontend.conf.in @ONLY)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/ibusfrontend.conf.in ibusfrontend.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ibusfrontend.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon"
        COMPONENT config)

if (ENABLE_LIBUUID)
target_link_libraries(ibusfrontend LibUUID::LibUUID)
endif()

=== src/lib/fcitx-wayland/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(input-method)
add_subdirectory(input-method-v2)
add_subdirectory(wlr-data-control)
add_subdirectory(blur)
add_subdirectory(plasma-window-management)
add_subdirectory(wlr-foreign-toplevel-management-unstable-v1)
add_subdirectory(fractional-scale-v1)
add_subdirectory(viewporter)
# Unused for now, introduced as a dependency to cursor-shape
add_subdirectory(tablet-v2)
add_subdirectory(cursor-shape)
#add_subdirectory(input-method-v3)

=== src/modules/wayland/CMakeLists.txt ===
add_fcitx5_addon(wayland waylandmodule.cpp waylandeventreader.cpp)
target_link_libraries(wayland Fcitx5::Core Wayland::Client Fcitx5::Wayland::Core PkgConfig::Gio Pthread::Pthread Fcitx5::Module::Notifications)

if (ENABLE_DBUS)
    target_link_libraries(wayland Fcitx5::Module::DBus)
endif()
if (ENABLE_X11)
    target_link_libraries(wayland Fcitx5::Module::XCB)
endif()
install(TARGETS wayland DESTINATION "${FCITX_INSTALL_ADDONDIR}")
configure_file(wayland.conf.in.in wayland.conf.in @ONLY)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/wayland.conf.in wayland.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/wayland.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon"
        COMPONENT config)
fcitx5_export_module(Wayland TARGET wayland BUILD_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}" HEADERS wayland_public.h INSTALL)

=== src/lib/fcitx-wayland/cursor-shape/CMakeLists.txt ===
ecm_add_wayland_client_protocol(CURSOR_SHAPE_PROTOCOL_SRCS
    PROTOCOL ${CMAKE_CURRENT_SOURCE_DIR}/cursor-shape-v1.xml
    BASENAME cursor-shape-v1)

set(FCITX_WAYLAND_CURSOR_SHAPE_PROTOCOL_SOURCES
    wp_cursor_shape_manager_v1.cpp
    wp_cursor_shape_device_v1.cpp
)

add_library(Fcitx5WaylandCursorShape STATIC ${FCITX_WAYLAND_CURSOR_SHAPE_PROTOCOL_SOURCES} ${CURSOR_SHAPE_PROTOCOL_SRCS})
set_target_properties(Fcitx5WaylandCursorShape PROPERTIES
  POSITION_INDEPENDENT_CODE ON
  )
target_include_directories(Fcitx5WaylandCursorShape PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}/..;${CMAKE_CURRENT_BINARY_DIR}>")
target_link_libraries(Fcitx5WaylandCursorShape PUBLIC Wayland::Client Fcitx5::Utils Fcitx5::Wayland::Core Fcitx5::Wayland::Tablet)

add_library(Fcitx5::Wayland::CursorShape ALIAS Fcitx5WaylandCursorShape)

=== debian/changelog ===
fcitx5 (5.1.14-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 10 Aug 2025 18:25:35 -0400

=== debian/control ===
Source: fcitx5
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 appstream,
 cmake (>= 3.6.0),
 dbus-daemon <!nocheck>,
 debhelper-compat (= 13),
 dh-exec,
 extra-cmake-modules,
 gettext,
 iso-codes,
 libbrotli-dev,
 libcairo2-dev,
 libdbus-1-dev [!linux-any],
 libegl1-mesa-dev,
 libenchant-2-dev,
 libevent-dev [!linux-any],
 libexpat1-dev,
 libfmt-dev,
 libgdk-pixbuf-2.0-dev,
 libjson-c-dev,
 libkvm-dev [kfreebsd-any],
 libpango1.0-dev,
 libsystemd-dev [linux-any],
 libuv1-dev [!linux-any],
 libwayland-bin [linux-any],
 libwayland-dev [linux-any],
 libwayland-egl-backend-dev [linux-any],
 libxcb-ewmh-dev,
 libxcb-icccm4-dev,
 libxcb-imdkit-dev (>= 1.0.5~),
 libxcb-randr0-dev,
 libxcb-shape0-dev,
 libxcb-xfixes0-dev,
 libxcb-xinerama0-dev,
 libxcb-xkb-dev,
 libxcb1-dev,
 libxkbcommon-x11-dev,
 libxkbfile-dev,
 pkgconf,
 unicode-cldr-core,
 uuid-dev,
 wayland-protocols [linux-any],
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/fcitx/fcitx5
Vcs-Git: https://salsa.debian.org/input-method-team/fcitx5.git
Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx5
Description: Fcitx Input Method Framework v5
 Fcitx5 is the next generation of fcitx input method framework. It
 provides pleasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, D-Bus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.

Package: fcitx5
Architecture: any
Depends:
 fcitx5-data (= ${source:Version}),
 fcitx5-modules (= ${binary:Version}),
 libfcitx5config6 (= ${binary:Version}),
 libfcitx5core7 (= ${binary:Version}),
 libfcitx5utils2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 fcitx5-config-qt,
 fcitx5-frontend-all,
 im-config (>= 0.44),
Suggests:
 fcitx5-chinese-addons,
 kde-config-fcitx5,
Conflicts:
 fcitx (<< 1:5),
 fcitx-bin (<< 1:5),
 fcitx-data (<< 1:5),
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package provides core fcitx5 framework files.

Package: fcitx5-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} (common data files)
 ${source:Extended-Description}
 .
 This package provides architecture-independent data files.

Package: fcitx5-frontend-all
Architecture: all
Multi-Arch: foreign
Section: metapackages
Depends:
 fcitx5-frontend-gtk3,
 fcitx5-frontend-gtk4,
 fcitx5-frontend-qt5,
 fcitx5-frontend-qt6,
 ${misc:Depends},
Suggests:
 fcitx5-frontend-fbterm,
 fcitx5-frontend-gtk2,
 fcitx5-frontend-tmux,
Description: ${source:Synopsis} (Frontend IM Module metapackage)
 ${source:Extended-Description}
 .
 This package depends on Input Method Modules (IM Modules) utilized
 by popular GUI libraries for better GUI input integration, currently
 include GTK3, GTK4, Qt5 and Qt6.

Package: fcitx5-modules
Architecture: any
Multi-Arch: same
Depends:
 fcitx5-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 fcitx5-module-dbus (<< 5.0.4-2),
 fcitx5-module-emoji (<< 5.0.20),
 fcitx5-module-fcitx4 (<< 5.0.4-2),
 fcitx5-module-ibus (<< 5.0.4-2),
 fcitx5-module-kimpanel (<< 5.0.4-2),
 fcitx5-module-quickphrase (<< 5.0.20),
 fcitx5-module-wayland (<< 5.0.20),
 fcitx5-module-xorg (<< 5.0.20),
Replaces:
 fcitx5-module-dbus (<< 5.0.4-2),
 fcitx5-module-emoji (<< 5.0.20),
 fcitx5-module-fcitx4 (<< 5.0.4-2),
 fcitx5-module-ibus (<< 5.0.4-2),
 fcitx5-module-kimpanel (<< 5.0.4-2),
 fcitx5-module-quickphrase (<< 5.0.20),
 fcitx5-module-wayland (<< 5.0.20),
 fcitx5-module-xorg (<< 5.0.20),
Provides:
 fcitx5-module-dbus,
 fcitx5-module-emoji,
 fcitx5-module-ibus,
 fcitx5-module-kimpanel,
 fcitx5-module-quickphrase,
 fcitx5-module-wayland [linux-any],
 fcitx5-module-xorg,
Description: ${source:Synopsis} (core modules)
 ${source:Extended-Description}
 .
 This package provides core modules for fcitx5 and depends on all
 input modules.

Package: fcitx5-modules-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 fcitx5-modules (= ${binary:Version}),
 libfcitx5core-dev (= ${binary:Version}),
 libfcitx5utils-dev (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (input modules dev files)
 ${source:Extended-Description}
 .
 This package provides development files for fcitx5 input modules.

Package: libfcitx5config-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libfcitx5config6 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (config library dev files)
 ${source:Extended-Description}
 .
 This package provides development files for fcitx5 config libraries.

Package: libfcitx5config6
Architecture: any
Section: libs
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (config library)
 ${source:Extended-Description}
 .
 This package provides fcitx5 config libraries.

Package: libfcitx5core-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libfcitx5config-dev (= ${binary:Version}),
 libfcitx5core7 (= ${binary:Version}),
 libfcitx5utils-dev (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (core library dev files)
 ${source:Extended-Description}
 .
 This package provides development files for fcitx5 core libraries.

Package: libfcitx5core7
Architecture: any
Section: libs
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (core library)
 ${source:Extended-Description}
 .
 This package provides fcitx5 core libraries.

Package: libfcitx5utils-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libfcitx5utils2 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (utils library dev files)
 ${source:Extended-Description}
 .
 This package provides development files for fcitx5 utils libraries.

Package: libfcitx5utils2
Architecture: any
Section: libs
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (utils library)
 ${source:Extended-Description}
 .
 This package provides fcitx5 utils libraries.

## fcitx5 5.1.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.13)
-project(fcitx VERSION 5.1.14)
+project(fcitx VERSION 5.1.15)
 set(FCITX_VERSION ${PROJECT_VERSION})
 
 find_package(ECM REQUIRED 1.0.0)
@@ -169,7 +169,7 @@
     set(REQUIRED_WAYLAND_COMPONENTS Client Cursor)
     find_package(Wayland 1.22 REQUIRED COMPONENTS ${REQUIRED_WAYLAND_COMPONENTS})
     find_package(WaylandScanner REQUIRED)
-    find_package(WaylandProtocols REQUIRED)
+    find_package(WaylandProtocols 1.39 REQUIRED)
     pkg_check_modules(Gio IMPORTED_TARGET gio-2.0)
 endif()

=== testing/testui/CMakeLists.txt ===
add_fcitx5_addon(testui testui.cpp)

target_link_libraries(testui
    Fcitx5::Core)
install(TARGETS testui DESTINATION "${FCITX_INSTALL_ADDONDIR}")
install(FILES testui.conf DESTINATION "${FCITX_INSTALL_PKGDATADIR}/testing/addon")

=== src/modules/imselector/CMakeLists.txt ===
add_fcitx5_addon(imselector imselector.cpp)
target_link_libraries(imselector Fcitx5::Core)
install(TARGETS imselector DESTINATION "${FCITX_INSTALL_ADDONDIR}")
configure_file(imselector.conf.in.in imselector.conf.in @ONLY)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/imselector.conf.in imselector.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/imselector.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon"
        COMPONENT config)

=== src/ui/classic/themes/default-dark/CMakeLists.txt ===
file(GLOB IMAGE_FILES *.png)

fcitx5_translate_desktop_file(theme-dark.conf.in theme.conf)

install(FILES ${IMAGE_FILES} ${CMAKE_CURRENT_BINARY_DIR}/theme.conf DESTINATION ${FCITX_INSTALL_PKGDATADIR}/themes/default-dark
        COMPONENT config)

=== debian/changelog ===
fcitx5 (5.1.15-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 25 Oct 2025 17:24:12 -0400

fcitx5 (5.1.14-4) unstable; urgency=medium

  * debian/copyright: Updated.
  * Manually trigger rebuild yet another time with gcc-15 toolchain.

 -- Boyuan Yang <byang@debian.org>  Wed, 01 Oct 2025 20:23:28 -0400

fcitx5 (5.1.14-3) unstable; urgency=medium

  * debian/control: Bump cmake version requirement to (>= 3.13).
  * Manually retrigger rebuild again. The buildd was not updated
    to gcc-15 toolchain in the previous build.

 -- Boyuan Yang <byang@debian.org>  Mon, 08 Sep 2025 09:54:25 -0400

fcitx5 (5.1.14-2) unstable; urgency=medium

  * Manually rebuild against GCC 15. This may help resolve some weird crashes
    around <format> in fcitx5-m17n.

 -- Boyuan Yang <byang@debian.org>  Sun, 07 Sep 2025 16:28:36 -0400

## fcitx5 5.1.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.13)
-project(fcitx VERSION 5.1.15)
+project(fcitx VERSION 5.1.16)
 set(FCITX_VERSION ${PROJECT_VERSION})
 
 find_package(ECM REQUIRED 1.0.0)

=== data/CMakeLists.txt ===
add_subdirectory(icon)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/fcitx5-configtool.desktop.in.in
               ${CMAKE_CURRENT_BINARY_DIR}/fcitx5-configtool.desktop.in @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/org.fcitx.Fcitx5.desktop.in.in
               ${CMAKE_CURRENT_BINARY_DIR}/org.fcitx.Fcitx5.desktop.in @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/fcitx5-diagnose.sh
               ${CMAKE_CURRENT_BINARY_DIR}/fcitx5-diagnose ESCAPE_QUOTES @ONLY)

fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/fcitx5-configtool.desktop.in
                              fcitx5-configtool.desktop)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/org.fcitx.Fcitx5.desktop.in
                              org.fcitx.Fcitx5.desktop)
fcitx5_translate_desktop_file(org.fcitx.Fcitx5.metainfo.xml.in
                              org.fcitx.Fcitx5.metainfo.xml XML)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.fcitx.Fcitx5.desktop"
              "${CMAKE_CURRENT_BINARY_DIR}/fcitx5-configtool.desktop"
        DESTINATION "${FCITX_INSTALL_DATADIR}/applications")

if (ENABLE_XDGAUTOSTART)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.fcitx.Fcitx5.desktop" DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/xdg/autostart)
endif()

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.fcitx.Fcitx5.metainfo.xml" DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

install(FILES fcitx5-configtool.sh RENAME fcitx5-configtool DESTINATION "${FCITX_INSTALL_BINDIR}" PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx5-diagnose" DESTINATION "${FCITX_INSTALL_BINDIR}" PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

install(DIRECTORY default DESTINATION "${FCITX_INSTALL_PKGDATADIR}" COMPONENT config)

if (WAYLAND_FOUND AND ENABLE_X11)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/20-fcitx-x11.in
                   ${CMAKE_CURRENT_BINARY_DIR}/20-fcitx-x11 @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/20-fcitx-x11" DESTINATION "${CMAKE_INSTALL_FULL_SYSCONFDIR}/xdg/Xwayland-session.d" PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
endif()

if (ENABLE_DBUS AND WAYLAND_FOUND)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/fcitx5-wayland-launcher.desktop.in.in
                   ${CMAKE_CURRENT_BINARY_DIR}/fcitx5-wayland-launcher.desktop.in @ONLY)
    fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/fcitx5-wayland-launcher.desktop.in
                                  fcitx5-wayland-launcher.desktop)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx5-wayland-launcher.desktop"
            DESTINATION "${FCITX_INSTALL_DATADIR}/applications")
endif()

=== po/CMakeLists.txt ===
fcitx5_install_translation(fcitx5)

=== src/CMakeLists.txt ===
add_definitions("-DFCITX_GETTEXT_DOMAIN=\"fcitx5\"")

add_subdirectory(lib)
add_subdirectory(modules)
add_subdirectory(frontend)
add_subdirectory(im)
add_subdirectory(ui)


if (ENABLE_SERVER)
    add_subdirectory(server)

    if (NOT BUILD_SHARED_FCITX_ADDON)
        fcitx5_get_addon_targets(ADDON_TARGETS modules frontend im ui)

        fcitx5_import_addons(fcitx5
            REGISTRY_VARNAME getStaticAddon
            ADDONS ${ADDON_TARGETS}
        )
    endif()
endif()

add_subdirectory(tools)

=== data/icon/CMakeLists.txt ===
foreach(size 16 22 24 32 48 128)
    install(DIRECTORY ${size}x${size} DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor"
             PATTERN .* EXCLUDE
             PATTERN *~ EXCLUDE)
endforeach(size 16 22 24 32 48 128)

install(DIRECTORY scalable DESTINATION "${CMAKE_INSTALL_DATADIR}/icons/hicolor"
         PATTERN ".*" EXCLUDE
         PATTERN "*~" EXCLUDE)

=== src/frontend/CMakeLists.txt ===
if (ENABLE_X11)
    add_subdirectory(xim)
endif()

if (WAYLAND_FOUND)
    add_subdirectory(waylandim)
endif()

if (ENABLE_DBUS)
    add_subdirectory(dbusfrontend)
    add_subdirectory(fcitx4frontend)
    add_subdirectory(ibusfrontend)
endif()

=== src/lib/CMakeLists.txt ===
add_subdirectory(fcitx-utils)
add_subdirectory(fcitx-config)
add_subdirectory(fcitx)

if (WAYLAND_FOUND)

    add_subdirectory(fcitx-wayland)
endif()

=== src/server/CMakeLists.txt ===
add_executable(fcitx5 main.cpp errorhandler.cpp)
target_link_libraries(fcitx5 Fcitx5::Core LibIntl::LibIntl)
if (ENABLE_KEYBOARD)
    target_link_libraries(fcitx5 keyboard)
endif()
if (EXECINFO_FOUND)
target_link_libraries(fcitx5 Execinfo::Execinfo)
endif()

if(HAVE_NO_DEPRECATED_DECLARATIONS)
    set_source_files_properties(main.cpp PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations")
endif()

install(TARGETS fcitx5 DESTINATION "${FCITX_INSTALL_BINDIR}")

=== src/ui/CMakeLists.txt ===
add_subdirectory(classic)

if (ENABLE_DBUS)
    add_subdirectory(kimpanel)
    add_subdirectory(virtualkeyboard)
endif()

=== testing/testfrontend/CMakeLists.txt ===
add_fcitx5_addon(testfrontend testfrontend.cpp)

target_link_libraries(testfrontend
    Fcitx5::Core)
install(TARGETS testfrontend DESTINATION "${FCITX_INSTALL_ADDONDIR}")
install(FILES testfrontend.conf DESTINATION "${FCITX_INSTALL_PKGDATADIR}/testing/addon")

fcitx5_export_module(TestFrontend TARGET testfrontend BUILD_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}" HEADERS testfrontend_public.h INSTALL)

=== src/frontend/dbusfrontend/CMakeLists.txt ===
add_fcitx5_addon(dbusfrontend dbusfrontend.cpp)
target_link_libraries(dbusfrontend Fcitx5::Core Fcitx5::Module::DBus)
install(TARGETS dbusfrontend DESTINATION "${FCITX_INSTALL_ADDONDIR}")
configure_file(dbusfrontend.conf.in.in dbusfrontend.conf.in @ONLY)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/dbusfrontend.conf.in dbusfrontend.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/dbusfrontend.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon"
        COMPONENT config)

=== src/frontend/fcitx4frontend/CMakeLists.txt ===
add_fcitx5_addon(fcitx4frontend fcitx4frontend.cpp)
target_link_libraries(fcitx4frontend Fcitx5::Core Fcitx5::Module::DBus)
if (ENABLE_X11)
    target_link_libraries(fcitx4frontend Fcitx5::Module::XCB XCB::XCB)
endif()
install(TARGETS fcitx4frontend DESTINATION "${FCITX_INSTALL_ADDONDIR}")
configure_file(fcitx4frontend.conf.in.in fcitx4frontend.conf.in @ONLY)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/fcitx4frontend.conf.in fcitx4frontend.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fcitx4frontend.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon"
        COMPONENT config)

=== debian/changelog ===
fcitx5 (5.1.16-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 26 Oct 2025 15:08:51 -0400

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Boyuan Yang <byang@debian.org>,
 Build-Depends:
  appstream,
- cmake (>= 3.6.0),
+ cmake (>= 3.13),
  dbus-daemon <!nocheck>,
  debhelper-compat (= 13),
  dh-exec,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

config-opt := -DUSE_FLATPAK_ICON=OFF -DENABLE_XDGAUTOSTART=OFF

ifneq (linux,$(DEB_HOST_ARCH_OS))
config-opt += -DUSE_SYSTEMD=OFF -DENABLE_WAYLAND=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(config-opt)

override_dh_auto_test:
	# DBus-related tests can't run in parallel
	dh_auto_test --no-parallel

## fcitx5 5.1.17

=== test/CMakeLists.txt ===
configure_file(testdir.h.in ${CMAKE_CURRENT_BINARY_DIR}/testdir.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(addon)

add_library(eventlooptests STATIC eventlooptests.cpp)
target_link_libraries(eventlooptests Fcitx5::Utils Pthread::Pthread)

set(FCITX_UTILS_TEST
    testflags
    teststringutils
    testkey
    testutf8
    testcolor
    testi18nstring
    testevent
    testlist
    testfs
    testlibrary
    testunixfd
    testmetastring
    testhandlertable
    testsignals
    testinputbuffer
    testlog
    testeventdispatcher
    testrect
    testfallbackuuid
    testsemver
    testenviron
    testfdstreambuf)

if (WIN32)
    list(APPEND FCITX_UTILS_TEST teststandardpaths_win)
else()
    list(APPEND FCITX_UTILS_TEST teststandardpath)
    list(APPEND FCITX_UTILS_TEST teststandardpaths_unix)
endif()

set(FCITX_UTILS_DBUS_TEST
    testdbusmessage
    testdbus
    testservicewatcher)

if(HAVE_NO_DEPRECATED_DECLARATIONS)
    set_source_files_properties(teststandardpath.cpp PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations")
endif()

set(testdbus_LIBS Pthread::Pthread)
set(testeventdispatcher_LIBS Pthread::Pthread)
set(testevent_LIBS eventlooptests)

if (NOT WIN32)
list(APPEND FCITX_UTILS_TEST testcustomeventloop)
set(testcustomeventloop_LIBS eventlooptests)
endif()

find_program(XVFB_BIN Xvfb)

add_executable(XvfbWrapper IMPORTED)
set_target_properties(XvfbWrapper PROPERTIES IMPORTED_LOCATION "${CMAKE_CURRENT_SOURCE_DIR}/xvfb_wrapper.sh")

if (ENABLE_DBUS)
    find_program(DBUS_DAEMON_BIN dbus-daemon)
    add_executable(DBusWrapper IMPORTED)
    set_target_properties(DBusWrapper PROPERTIES IMPORTED_LOCATION "${CMAKE_CURRENT_SOURCE_DIR}/dbus_wrapper.sh")

    foreach(TESTCASE ${FCITX_UTILS_DBUS_TEST})
        add_executable(${TESTCASE} ${TESTCASE}.cpp)
        target_link_libraries(${TESTCASE} Fcitx5::Utils ${${TESTCASE}_LIBS})

        if (DBUS_DAEMON_BIN)
            add_test(NAME ${TESTCASE}
                    COMMAND DBusWrapper "${DBUS_DAEMON_BIN}" "$<TARGET_FILE:${TESTCASE}>" ${${TESTCASE}_ARGS})
        endif()
    endforeach()
endif()

foreach(TESTCASE ${FCITX_UTILS_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} Fcitx5::Utils ${${TESTCASE}_LIBS})
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE} ${${TESTCASE}_ARGS})
endforeach()
set_target_properties(testlibrary PROPERTIES LINK_FLAGS "-rdynamic")

set(FCITX_CONFIG_TEST
    testconfig)

if (ENABLE_DBUS)
    list(APPEND FCITX_CONFIG_TEST testconfigdbus)
endif()

foreach(TESTCASE ${FCITX_CONFIG_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} Fcitx5::Config)
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE})
endforeach()

set(testinputcontext_LIBS Fcitx5::Module::TestFrontend Fcitx5::Module::TestIM)
set(testinstance_LIBS Fcitx5::Module::TestFrontend)

set(FCITX_CORE_TEST
    testinputcontext
    testsurroundingtext
    testaddon
    testmenu
    testuserinterfacemanager
    testelement
    testcandidatelist
    testicontheme
    testtext
    testinstance)

foreach(TESTCASE ${FCITX_CORE_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} Fcitx5::Core ${${TESTCASE}_LIBS})
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE} ${${TESTCASE}_ARGS})
endforeach()

add_dependencies(testaddon dummyaddon)
add_dependencies(testinstance copy-addon testfrontend testim)
add_dependencies(testinputcontext copy-addon testfrontend testim)

if (ENABLE_KEYBOARD)
    add_executable(testxkbrules testxkbrules.cpp ../src/im/keyboard/xkbrules.cpp ../src/im/keyboard/xmlparser.cpp)
    target_compile_definitions(testxkbrules PRIVATE "-D_TEST_XKBRULES")
    target_include_directories(testxkbrules PRIVATE ../src)
    target_link_libraries(testxkbrules Fcitx5::Core Expat::Expat)
    add_test(NAME testxkbrules COMMAND testxkbrules)

    add_executable(testisocodes testisocodes.cpp ../src/im/keyboard/isocodes.cpp)
    target_compile_definitions(testisocodes PRIVATE "-D_TEST_XKBRULES")
    target_include_directories(testisocodes PRIVATE ../src)
    target_link_libraries(testisocodes Fcitx5::Core nlohmann_json::nlohmann_json)
    add_test(NAME testisocodes COMMAND testisocodes)

    add_executable(testcompose testcompose.cpp)
    target_link_libraries(testcompose Fcitx5::Core Fcitx5::Module::TestFrontend XKBCommon::XKBCommon keyboard)
    add_test(NAME testcompose COMMAND testcompose)
endif()

if (TARGET emoji)
add_executable(testemoji testemoji.cpp)
target_link_libraries(testemoji Fcitx5::Core Fcitx5::Module::Emoji)
add_dependencies(testemoji emoji emoji.conf.in-fmt)
add_test(NAME testemoji COMMAND testemoji)
endif()

add_executable(testunicode testunicode.cpp)
target_link_libraries(testunicode Fcitx5::Core Fcitx5::Module::TestFrontend Fcitx5::Module::TestIM)
add_dependencies(testunicode copy-addon unicode testui testfrontend testim)
add_test(NAME testunicode COMMAND testunicode)


if (ENABLE_KEYBOARD)
    add_executable(testspell testspell.cpp)
    target_link_libraries(testspell Fcitx5::Core Fcitx5::Module::TestFrontend keyboard)
    add_dependencies(testspell copy-addon spell testui testfrontend spell_en_dict)
    add_test(NAME testspell COMMAND testspell)
endif()

add_executable(testquickphrase testquickphrase.cpp)
target_link_libraries(testquickphrase Fcitx5::Core Fcitx5::Module::QuickPhrase Fcitx5::Module::TestFrontend Fcitx5::Module::TestIM)
add_dependencies(testquickphrase copy-addon quickphrase testui testfrontend testim)
add_test(NAME testquickphrase COMMAND testquickphrase)

if (ENABLE_X11)
add_executable(testxim testxim.cpp)
target_link_libraries(testxim Fcitx5::Core Fcitx5::Module::TestIM Pthread::Pthread XCB::XCB XCB::AUX XCBImdkit::XCBImdkit)
add_dependencies(testxim copy-addon xim testui testfrontend testim)

# FIXME: Test may fail on some system
#if (XVFB_BIN)
#    add_test(NAME testxim COMMAND XvfbWrapper "${XVFB_BIN}" "${CMAKE_CURRENT_BINARY_DIR}/testxim")
#endif()
endif()

=== src/im/keyboard/CMakeLists.txt ===
add_library(keyboard STATIC keyboard.cpp isocodes.cpp xkbrules.cpp xmlparser.cpp longpress.cpp compose.cpp)
target_link_libraries(keyboard Fcitx5::Core Expat::Expat LibIntl::LibIntl Fcitx5::Module::Spell Fcitx5::Module::Notifications XKBCommon::XKBCommon Fcitx5::Module::QuickPhrase nlohmann_json::nlohmann_json)
if (ENABLE_X11)
    target_link_libraries(keyboard Fcitx5::Module::XCB)
endif()
if (TARGET Fcitx5::Module::Emoji)
    target_link_libraries(keyboard Fcitx5::Module::Emoji)
endif()
configure_file(keyboard.conf.in.in keyboard.conf.in @ONLY)
fcitx5_translate_desktop_file(${CMAKE_CURRENT_BINARY_DIR}/keyboard.conf.in keyboard.conf)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/keyboard.conf" DESTINATION "${FCITX_INSTALL_PKGDATADIR}/addon"
        COMPONENT config)
fcitx5_export_module(Keyboard TARGET keyboard BUILD_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}" HEADERS keyboard_public.h)

=== debian/changelog ===
fcitx5 (5.1.17-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Replace libjson-c-dev with nlohmann-json3-dev.

 -- Boyuan Yang <byang@debian.org>  Tue, 23 Dec 2025 15:35:53 -0500

=== debian/control ===
--- 
+++ 
@@ -22,8 +22,8 @@
  libexpat1-dev,
  libfmt-dev,
  libgdk-pixbuf-2.0-dev,
- libjson-c-dev,
  libkvm-dev [kfreebsd-any],
+ nlohmann-json3-dev,
  libpango1.0-dev,
  libsystemd-dev [linux-any],
  libuv1-dev [!linux-any],
